; #########################################################################

;     include files
;     ~~~~~~~~~~~~~
      include d:\masm32\include\windows.inc
      include d:\masm32\include\masm32.inc
      include d:\masm32\include\gdi32.inc
      include d:\masm32\include\user32.inc
      include d:\masm32\include\kernel32.inc
      include d:\masm32\include\Comctl32.inc
      include d:\masm32\include\comdlg32.inc
      include d:\masm32\include\shell32.inc
      include d:\masm32\include\oleaut32.inc

;     libraries
;     ~~~~~~~~~
      includelib d:\masm32\lib\masm32.lib
      includelib d:\masm32\lib\gdi32.lib
      includelib d:\masm32\lib\user32.lib
      includelib d:\masm32\lib\kernel32.lib
      includelib d:\masm32\lib\Comctl32.lib
      includelib d:\masm32\lib\comdlg32.lib
      includelib d:\masm32\lib\shell32.lib
      includelib d:\masm32\lib\oleaut32.lib

; #########################################################################

        ;=================
        ; Local prototypes
        ;=================
        WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
        TopXY            PROTO :DWORD,:DWORD
        Paint_Proc       PROTO :DWORD
        RegisterWinClass PROTO :DWORD,:DWORD,:DWORD,:DWORD,:DWORD
        MsgLoop          PROTO
        Main             PROTO

        DialogOneProc 	PROTO :DWORD,:DWORD,:DWORD,:DWORD
        DlgProc 		PROTO :DWORD,:DWORD,:DWORD,:DWORD
        CheckboxWndProc	PROTO :DWORD,:DWORD,:DWORD,:DWORD
        setup_form		PROTO :DWORD
        nseed			PROTO :DWORD
        nrandom			PROTO :DWORD
        check_data		PROTO :DWORD

;        wsprintfA PROTO C :DWORD,:VARARG
;        wsprintf equ <wsprintfA>

      ;=============
      ; Local macros
      ;=============

      szText MACRO Name, Text:VARARG
        LOCAL lbl
          jmp lbl
            Name db Text,0
          lbl:
        ENDM

      m2m MACRO M1, M2
        push M2
        pop  M1
      ENDM

      return MACRO arg
        mov eax, arg
        ret
      ENDM

      stralloc MACRO ln
        invoke SysAllocStringByteLen,0,ln
      ENDM

      strfree MACRO strhandle
        invoke SysFreeString,strhandle
      ENDM

    ; -------------------------
    ; initialised GLOBAL value
    ; -------------------------
      IGLOBAL MACRO variable:VARARG
      .data
        variable
      .code
      ENDM

    ; --------------------------------
    ; initialised GLOBAL string value
    ; --------------------------------
      STRING MACRO variable:REQ,args:VARARG
      .data
        variable db args,0
      .code
      ENDM

    ; ---------------------
    ; literal string MACRO
    ; ---------------------
      literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
      SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM
    ; --------------------------------
    ; string OFFSET for manual coding
    ; --------------------------------
      CTXT MACRO quoted_text:VARARG
        EXITM <offset literal(quoted_text)>
      ENDM

      ShellAboutBox MACRO handle,IconHandle,quoted_Text_1,quoted_Text_2:VARARG
        LOCAL AboutTitle,AboutMsg,buffer
          .data
            AboutTitle db quoted_Text_1,0
            AboutMsg   db quoted_Text_2,0
            buffer db 128 dup (0)
          .code
        mov esi, offset AboutTitle
        mov edi, offset buffer
        mov ecx, lengthof AboutTitle
        rep movsb
        invoke ShellAbout,handle,ADDR buffer,ADDR AboutMsg,IconHandle
      ENDM

      AppModel MACRO Processor
        Processor             ;; Processor type
        .model flat, stdcall  ;; 32 bit memory model
        option casemap :none  ;; case sensitive
      ENDM

      DisplayMenu MACRO handl, IDnum
        invoke LoadMenu,hInstance,IDnum
        invoke SetMenu,handl,eax
      ENDM

      DisplayWindow MACRO handl, ShowStyle
        invoke ShowWindow,handl, ShowStyle
        invoke UpdateWindow,handl
      ENDM

      AutoScale MACRO swidth, sheight
        invoke GetPercent,sWid,swidth
        mov Wwd, eax
        invoke GetPercent,sHgt,sheight
        mov Wht, eax

        invoke TopXY,Wwd,sWid
        mov Wtx, eax

        invoke TopXY,Wht,sHgt
        mov Wty, eax
      ENDM

      SingleInstanceOnly MACRO lpClassName
        invoke FindWindow,lpClassName,NULL
        cmp eax, 0
        je @F
          push eax
          invoke ShowWindow,eax,SW_RESTORE
          pop eax
          invoke SetForegroundWindow,eax
          mov eax, 0
          ret
        @@:
      ENDM

      GLOBAL MACRO var1,var2,var3,var4,var5,var6,var7,var8,var9,var0,
                   varA,varB,varC,varD,varE,varF,varG,varH,varI,varJ
        .data?
          var1
          var2
          var3
          var4
          var5
          var6
          var7
          var8
          var9
          var0
          varA
          varB
          varC
          varD
          varE
          varF
          varG
          varH
          varI
          varJ
        .code
      ENDM

    ; --------------------------------------------
    ; equates to use directly in the message loop
    ; --------------------------------------------
        m_hWnd   equ <msg.hwnd>
        m_Msg    equ <msg.message>
        m_wParam equ <msg.wParam>
        m_lParam equ <msg.lParam>

        
IDD_MAIN			EQU 	101
IDD_DLG1			EQU 	102
IDC_TABCONTROL		EQU 	1002
MAX_INSTRUCTIONS	equ		256
        

    				.data
nrandom_seed 		dd 		12345678

szDisplayName		db 		"MicroChip C-Language Simulator",0
szSetCount			db		'Set count:',0
szGameCount			db		'Game count:',0
szEnergyLeft		db		'Energy left:',0
szTimeLeft			db		'Elapsed time:',0
szWelcome			db		'Written by Tan Ghee Siak, v0.01  July 2009',0
szuChip				db		'Simulator',0

szFontName			db		'MS Sans Serif',0
szTahoma			db		'Tahoma',0

					;*====	Superclass information	====
CheckboxClass		db		'CHECKBOX',0
MyChkBoxClass		db		'SCHECKBOX',0
szRndErr			db		"Random value out of required rang",0

					;*====	Strings for labels	====
szInclude			db		'#include <p18f4520.h>',0
szMain				db		"void main (void)",0
szOpenBrace			db		"{",0
szCloseBrace		db		"}",0
szPauseRtn			db		"void ShortDelay (void)",0
szInt				db		"int i ;",0
szForLp				db		"for (i=0 ; i < 10000; i++)",0
szNop				db		"Nop() ;",0
szPortA				db		"  Port A ",0
szPortB				db		"  Port B ",0
szPortC				db		"  Port C ",0
szPortD				db		"  Port D ",0
szBit7				db		" 7 ",0
szBit6				db		" 6 ",0
szBit5				db		" 5 ",0
szBit4				db		" 4 ",0
szBit3				db		" 3 ",0
szBit2				db		" 2 ",0
szBit1				db		" 1 ",0
szBit0				db		" 0 ",0
szOut				db		"Out",0
szIn				db		"In",0

szNewGame			db		"New Game",0
szNewSet			db		"New Set",0
szStart				db		"Start Game",0
szClick				db		"Click Instruction",0
szAccept			db		"Accept Changes",0
szClickNInstr		db		"Click next instruction",0

StaticClass			db		"STATIC",0	
ButtonClass			db		"BUTTON",0

TRIS_MSG			db		"TRIS  = 0b          ;  ",0
TRISbits_MSG		db		"TRIS bits.TRIS   = 0 ;",0
PORT_MSG			db		"PORT  = 0b         ; ",0
PORTbits_MSG		db		"PORT bits.R   = 0 ;",0
szChkClicked		db		"Checkbox clicked",0
szPortAClicked		db		"Port A clicked",0
szPortBClicked		db		"Port B clicked",0
szPortCClicked		db		"Port C clicked",0
szPortDClicked		db		"Port D clicked",0
szTRISAClicked		db		"TRIS A clicked",0
sz700				db		"PORT ID 700 done",0
szClickInstr		db		"Click instruction to start",0

szPortData			db		"Port A:"
szPortAD			db		"   Port B:"
szPortBD			db		"   Port C:"
szPortCD			db		"   Port D:"
szPortDD			db		"   Port "
szPort				db		"  was clicked"
szNull				db		0

szTrisData			db		"Tris A:"
szTrisAD			db		"   Tris B:"
szTrisBD			db		"   Tris C:"
szTrisCD			db		"   Tris D:"
szTrisDD			db		"   Tris "
szTris				db		"  was clicked",0

MinStr				db		30h,30h,3Ah
SecStr				db		30h,30h,0

szEngyLoss			db		"     errors. Energy subtracted. You have "
szEngyLeft			db		"     energy left.",0 

szWrongLine			db		"You have clicked wrong line. Please click on the right instruction",0
szNoEnergy			db		"You have no energy left, restartwith new energy level?",0
szQuit				db		"Do you want to quit?",0

    				.data?

TCItem				TC_ITEM		<?>

IDClicked			dd		?								; ID of last control clicked

PortA_X				dd		?
PortB_X				dd		?

PortA_ID			dd		?
PortB_ID			dd		?
PortC_ID			dd		?
PortD_ID			dd		?

hndOffs				dd		?					; offset to handle

					;*====	Checkbox Control handle	====
hCHECKBOX1			dd		1 dup (?)			; instruction 1 checkbox handle
hCHECKBOX2			dd		1 dup (?)			; instruction 2 checkbox handle
hCHECKBOX3			dd		1 dup (?)			; instruction 3 checkbox handle
hCHECKBOX4			dd		1 dup (?)			; instruction 4 checkbox handle
hCHECKBOX5			dd		1 dup (?)			; instruction 5 checkbox handle
hCHECKBOX6			dd		1 dup (?)			; instruction 6 checkbox handle
hCHECKBOX7			dd		1 dup (?)			; instruction 7 checkbox handle
hCHECKBOX8			dd		1 dup (?)			; instruction 8 checkbox handle
hCHECKBOX9			dd		1 dup (?)			; instruction 9 checkbox handle
hCHECKBOX10			dd		1 dup (?)			; instruction 10 checkbox handle
hCHECKBOX11			dd		1 dup (?)			; instruction 11 checkbox handle
hCHECKBOX12			dd		1 dup (?)			; instruction 12 checkbox handle
hCHECKBOX13			dd		1 dup (?)			; instruction 13 checkbox handle
hCHECKBOX14			dd		1 dup (?)			; instruction 14 checkbox handle
hCHECKBOX15			dd		1 dup (?)			; instruction 15 checkbox handle
hCHECKBOX16			dd		1 dup (?)			; instruction 16 checkbox handle
hCHECKBOX17			dd		1 dup (?)			; instruction 17 checkbox handle
hCHECKBOX18			dd		1 dup (?)			; instruction 18 checkbox handle
hCHECKBOX19			dd		1 dup (?)			; instruction 19 checkbox handle
hCHECKBOX20			dd		1 dup (?)			; instruction 20 checkbox handle
hCHECKBOX21			dd		1 dup (?)			; instruction 21 checkbox handle
hCHECKBOX22			dd		1 dup (?)			; instruction 22 checkbox handle
hCHECKBOX23			dd		1 dup (?)			; instruction 23 checkbox handle
hCHECKBOX24			dd		1 dup (?)			; instruction 24 checkbox handle
hCHECKBOX25			dd		1 dup (?)			; instruction 25 checkbox handle
hCHECKBOXPause		dd		1 dup (?)			; instruction pause checkbox handle

					;*====	Port A control handle	====
hSPORTA0			dd		1 dup (?)			; port A bit 0 label control handle
hSPORTA1			dd		1 dup (?)			; port A bit 1 label control handle
hSPORTA2			dd		1 dup (?)			; port A bit 2 label control handle
hSPORTA3			dd		1 dup (?)			; port A bit 3 label control handle
hSPORTA4			dd		1 dup (?)			; port A bit 4 label control handle
hSPORTA5			dd		1 dup (?)			; port A bit 5 label control handle
hSPORTA6			dd		1 dup (?)			; port A bit 6 label control handle
hSPORTA7			dd		1 dup (?)			; port A bit 7 label control handle

					;*====	TRIS A control handle	====
hSTRISA0			dd		1 dup (?)			; TRIS A bit 0 label control handle
hSTRISA1			dd		1 dup (?)			; TRIS A bit 1 label control handle
hSTRISA2			dd		1 dup (?)			; TRIS A bit 2 label control handle
hSTRISA3			dd		1 dup (?)			; TRIS A bit 3 label control handle
hSTRISA4			dd		1 dup (?)			; TRIS A bit 4 label control handle
hSTRISA5			dd		1 dup (?)			; TRIS A bit 5 label control handle
hSTRISA6			dd		1 dup (?)			; TRIS A bit 6 label control handle
hSTRISA7			dd		1 dup (?)			; TRIS A bit 7 label control handle

					;*====	Port B control handle	====
hSPORTB0			dd		1 dup (?)			; port B bit 0 label control hBndle
hSPORTB1			dd		1 dup (?)			; port B bit 1 label control hBndle
hSPORTB2			dd		1 dup (?)			; port B bit 2 label control hBndle
hSPORTB3			dd		1 dup (?)			; port B bit 3 label control hBndle
hSPORTB4			dd		1 dup (?)			; port B bit 4 label control hBndle
hSPORTB5			dd		1 dup (?)			; port B bit 5 label control hBndle
hSPORTB6			dd		1 dup (?)			; port B bit 6 label control hBndle
hSPORTB7			dd		1 dup (?)			; port B bit 7 label control hBndle

					;*====	TRIS B control handle	====
hSTRISB0			dd		1 dup (?)			; TRIS B bit 0 lBbel control hBndle
hSTRISB1			dd		1 dup (?)			; TRIS B bit 1 lBbel control hBndle
hSTRISB2			dd		1 dup (?)			; TRIS B bit 2 lBbel control hBndle
hSTRISB3			dd		1 dup (?)			; TRIS B bit 3 lBbel control hBndle
hSTRISB4			dd		1 dup (?)			; TRIS B bit 4 lBbel control hBndle
hSTRISB5			dd		1 dup (?)			; TRIS B bit 5 lBbel control hBndle
hSTRISB6			dd		1 dup (?)			; TRIS B bit 6 lBbel control hBndle
hSTRISB7			dd		1 dup (?)			; TRIS B bit 7 lBbel control hBndle

					;*====	PORT C control handle	====
hSPORTC0			dd		1 dup (?)			; port C bit 0 label control hCndle
hSPORTC1			dd		1 dup (?)			; port C bit 1 label control hCndle
hSPORTC2			dd		1 dup (?)			; port C bit 2 label control hCndle
hSPORTC3			dd		1 dup (?)			; port C bit 3 label control hCndle
hSPORTC4			dd		1 dup (?)			; port C bit 4 label control hCndle
hSPORTC5			dd		1 dup (?)			; port C bit 5 label control hCndle
hSPORTC6			dd		1 dup (?)			; port C bit 6 label control hCndle
hSPORTC7			dd		1 dup (?)			; port C bit 7 label control hCndle

					;*====	TRIS C control handle	====
hSTRISC0			dd		1 dup (?)			; TRIS C bit 0 lCbel control hCndle
hSTRISC1			dd		1 dup (?)			; TRIS C bit 1 lCbel control hCndle
hSTRISC2			dd		1 dup (?)			; TRIS C bit 2 lCbel control hCndle
hSTRISC3			dd		1 dup (?)			; TRIS C bit 3 lCbel control hCndle
hSTRISC4			dd		1 dup (?)			; TRIS C bit 4 lCbel control hCndle
hSTRISC5			dd		1 dup (?)			; TRIS C bit 5 lCbel control hCndle
hSTRISC6			dd		1 dup (?)			; TRIS C bit 6 lCbel control hCndle
hSTRISC7			dd		1 dup (?)			; TRIS C bit 7 lCbel control hCndle

					;*====	Port D control hDndle	====
hSPORTD0			dd		1 dup (?)			; port D bit 0 label control hDndle
hSPORTD1			dd		1 dup (?)			; port D bit 1 label control hDndle
hSPORTD2			dd		1 dup (?)			; port D bit 2 label control hDndle
hSPORTD3			dd		1 dup (?)			; port D bit 3 label control hDndle
hSPORTD4			dd		1 dup (?)			; port D bit 4 label control hDndle
hSPORTD5			dd		1 dup (?)			; port D bit 5 label control hDndle
hSPORTD6			dd		1 dup (?)			; port D bit 6 label control hDndle
hSPORTD7			dd		1 dup (?)			; port D bit 7 label control hDndle

					;*====	TRIS D control handle	====
hSTRISD0			dd		1 dup (?)			; TRIS D bit 0 lDbel control hDndle
hSTRISD1			dd		1 dup (?)			; TRIS D bit 1 lDbel control hDndle
hSTRISD2			dd		1 dup (?)			; TRIS D bit 2 lDbel control hDndle
hSTRISD3			dd		1 dup (?)			; TRIS D bit 3 lDbel control hDndle
hSTRISD4			dd		1 dup (?)			; TRIS D bit 4 lDbel control hDndle
hSTRISD5			dd		1 dup (?)			; TRIS D bit 5 lDbel control hDndle
hSTRISD6			dd		1 dup (?)			; TRIS D bit 6 lDbel control hDndle
hSTRISD7			dd		1 dup (?)			; TRIS D bit 7 lDbel control hDndle

					;*====	LED static label	====
hSLED3				dd		1 dup (?)			; static label for LED3
hSLED2				dd		1 dup (?)			; static label for LED2
hSLED1				dd		1 dup (?)			; static label for LED1
hSLED0				dd		1 dup (?)			; static label for LED0

					;*====	Counter control handle	====
hSGCount			dd		1 dup (?)			; static label for game count
hSSCount			dd		1 dup (?)			; static label for set count
hSECount			dd		1 dup (?)			; static label for energy count

					;*====	Button control handle	====
hbNGame				dd		1 dup (?)			; new game button control handle
hbNSet				dd		1 dup (?)			; new set button control handle
hbAccept			dd		1 dup (?)			; accept change button control handle

					;*====	Instruction arrays	====
					;*====	0 = TRIS			====
					;*====	1 = TRISbits		====
					;*====	2 = PORT			====
					;*====	3 = PORTbits		====
InstrList			db		MAX_INSTRUCTIONS dup (?)	; instruction type list for 256 lines
IPortList			db		MAX_INSTRUCTIONS dup (?)	; port name type list for 256 lines
IBitList			db		MAX_INSTRUCTIONS dup (?)	; bit number type list for 256 lines
IDataList			db		MAX_INSTRUCTIONS dup (?)	; data for instruction list for 256 lines
IDTypList			db		MAX_INSTRUCTIONS dup (?)	; data type for instruction list for 256 lines
ErrLineList			db		MAX_INSTRUCTIONS dup (?)	; error line list for 256 lines
ErrDataList			db		MAX_INSTRUCTIONS dup (?)	; error data list for 256 lines
StrList				db		MAX_INSTRUCTIONS*24 dup (?)	; string list array

hInstance 			dd 		?
CommandLine 		dd 		?
hIcon 				dd 		?
hCursor 			dd 		?
sWid 				dd 		?
sHgt 				dd 		?
hWnd 				dd 		?
hTab				dd		?

OldLblWndProc		dd		?								; 
hFont				dd		?
Seed				dd		?

Strptr				dd		?
WStyle				dd		?
EStyle				dd		?
PostnX				dd		?
PostnY				dd		?
Wdth				dd		?
Height				dd		?

YellowBrush			dd		?

PortA_D				db		1 dup (?)						; Port A data state
TrisA_D				db		?								; Tris A data state

PortB_D				db		?								; Port B data state
TrisB_D				db		?								; Tris B data state

PortC_D				db		?								; Port C data state
TrisC_D				db		?								; Tris C data state

PortD_D				db		?								; Port D data state
TrisD_D				db		?								; Tris D data state

					;*====	Current state variables	====
CurInstr			db		1 dup (?)						; current instruction
CurPort				db		1 dup (?)						; current port name
CurBit				db		1 dup (?)						; current bit number
CurData				db		1 dup (?)						; current data
CurDTyp				db		1 dup (?)						; current data type
CurInpD				db		1 dup (?)						; current input data
CurSet				db		1 dup (?)						; current set number
CurGame				db		1 dup (?)						; current game number

PData				db		?								; port data
CurEnergy			db		?								; current energy left
CurLine				db		?								; current line on progress
ClickLine			db		?								; line number clicked
RunState			db		?								; current running state: 0=boot up, 1=Running, 2=set completed

					;*====	Byte bit check status	====
NoBitErr			db		?					; number of bit error
BitErrList			db		8 dup (?)			; bit position of bit that are incorrect

szHex				db		3 dup (?)			;
szErrStr			db		4 dup (?)			; 
					
; ########################### Inserted modules ############################

      include Statusbr.asm
      include uChipfrm.asm

; #########################################################################

